
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Dashboard_widgetsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const dashboard_widgets = await db.dashboard_widgets.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        widget_type: data.widget_type
        ||
        null
            ,
            
        config_json: data.config_json
        ||
        null
            ,
            
        layout_x: data.layout_x
        ||
        null
            ,
            
        layout_y: data.layout_y
        ||
        null
            ,
            
        layout_w: data.layout_w
        ||
        null
            ,
            
        layout_h: data.layout_h
        ||
        null
            ,
            
        is_visible: data.is_visible
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await dashboard_widgets.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return dashboard_widgets;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const dashboard_widgetsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                widget_type: item.widget_type
            ||
            null
            ,
            
                config_json: item.config_json
            ||
            null
            ,
            
                layout_x: item.layout_x
            ||
            null
            ,
            
                layout_y: item.layout_y
            ||
            null
            ,
            
                layout_w: item.layout_w
            ||
            null
            ,
            
                layout_h: item.layout_h
            ||
            null
            ,
            
                is_visible: item.is_visible
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const dashboard_widgets = await db.dashboard_widgets.bulkCreate(dashboard_widgetsData, { transaction });

        // For each item created, replace relation files
        

        return dashboard_widgets;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const dashboard_widgets = await db.dashboard_widgets.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.widget_type !== undefined) updatePayload.widget_type = data.widget_type;
        
        
        if (data.config_json !== undefined) updatePayload.config_json = data.config_json;
        
        
        if (data.layout_x !== undefined) updatePayload.layout_x = data.layout_x;
        
        
        if (data.layout_y !== undefined) updatePayload.layout_y = data.layout_y;
        
        
        if (data.layout_w !== undefined) updatePayload.layout_w = data.layout_w;
        
        
        if (data.layout_h !== undefined) updatePayload.layout_h = data.layout_h;
        
        
        if (data.is_visible !== undefined) updatePayload.is_visible = data.is_visible;
        
        
        updatePayload.updatedById = currentUser.id;

        await dashboard_widgets.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await dashboard_widgets.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return dashboard_widgets;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const dashboard_widgets = await db.dashboard_widgets.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of dashboard_widgets) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of dashboard_widgets) {
                await record.destroy({transaction});
            }
        });


        return dashboard_widgets;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const dashboard_widgets = await db.dashboard_widgets.findByPk(id, options);

        await dashboard_widgets.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await dashboard_widgets.destroy({
            transaction
        });

        return dashboard_widgets;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const dashboard_widgets = await db.dashboard_widgets.findOne(
            { where },
            { transaction },
        );

        if (!dashboard_widgets) {
            return dashboard_widgets;
        }

        const output = dashboard_widgets.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await dashboard_widgets.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'dashboard_widgets',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.config_json) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'dashboard_widgets',
                        'config_json',
                        filter.config_json,
                    ),
                };
            }
            

            
            

            
            if (filter.layout_xRange) {
                const [start, end] = filter.layout_xRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    layout_x: {
                    ...where.layout_x,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    layout_x: {
                    ...where.layout_x,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.layout_yRange) {
                const [start, end] = filter.layout_yRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    layout_y: {
                    ...where.layout_y,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    layout_y: {
                    ...where.layout_y,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.layout_wRange) {
                const [start, end] = filter.layout_wRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    layout_w: {
                    ...where.layout_w,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    layout_w: {
                    ...where.layout_w,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.layout_hRange) {
                const [start, end] = filter.layout_hRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    layout_h: {
                    ...where.layout_h,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    layout_h: {
                    ...where.layout_h,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.widget_type) {
                where = {
                    ...where,
                widget_type: filter.widget_type,
            };
            }
            
            if (filter.is_visible) {
                where = {
                    ...where,
                is_visible: filter.is_visible,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.dashboard_widgets.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'dashboard_widgets',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.dashboard_widgets.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

